#include "main.h"

#define Data_Num 100 //ɰ

/* Base address of the Flash sectors */
#define ADDR_FLASH_SECTOR_0     ((uint32_t)0x08000000) /* Base @ of Sector 0, 16 Kbytes */
#define ADDR_FLASH_SECTOR_1     ((uint32_t)0x08004000) /* Base @ of Sector 1, 16 Kbytes */
#define ADDR_FLASH_SECTOR_2     ((uint32_t)0x08008000) /* Base @ of Sector 2, 16 Kbytes */
#define ADDR_FLASH_SECTOR_3     ((uint32_t)0x0800C000) /* Base @ of Sector 3, 16 Kbytes */
#define ADDR_FLASH_SECTOR_4     ((uint32_t)0x08010000) /* Base @ of Sector 4, 64 Kbytes */
#define ADDR_FLASH_SECTOR_5     ((uint32_t)0x08020000) /* Base @ of Sector 5, 128 Kbytes */
#define FLASH_Sector_0          ((uint16_t)0x0000) /*!< Sector Number 0 */
#define FLASH_Sector_1          ((uint16_t)0x0008) /*!< Sector Number 1 */
#define FLASH_Sector_2          ((uint16_t)0x0010) /*!< Sector Number 2 */
#define FLASH_Sector_3          ((uint16_t)0x0018) /*!< Sector Number 3 */
#define FLASH_Sector_4          ((uint16_t)0x0020) /*!< Sector Number 4 */
#define FLASH_Sector_5          ((uint16_t)0x0028) /*!< Sector Number 5 */


//һfloat͵Ĳ
//ADDR 0---Data_Num
float flash_Read_Float(uint32_t ADDR)
{
    union
    {
        float f;
        uint32_t c;
    }fc;
    fc.c= *(__IO uint32_t*)(ADDR_FLASH_SECTOR_5+ADDR*4);//5
    return  fc.f;
}
//


//flashдһfloat͵Ĳ
//ADDR 0--99
void flash_Write_Float(uint32_t ADDR,float data)
{
    union
    {
        float f;
        uint32_t c;
    }fc1[Data_Num];
    for(int i=0;i<Data_Num;i++)
    {
        fc1[i].c= *(__IO uint32_t*)(ADDR_FLASH_SECTOR_5+i*4);//11
    }
    fc1[ADDR].f=data;
    FLASH_Unlock();             //FLASH
    FLASH_DataCacheCmd(DISABLE);
    FLASH_ErasePage(ADDR_FLASH_SECTOR_5);
    for(int i=0;i<Data_Num;i++)
    {
        FLASH_ProgramWord(ADDR_FLASH_SECTOR_5+i*4,fc1[i].c);//д
    }
    FLASH_DataCacheCmd(ENABLE); //FLASH,ݻ
    FLASH_Lock();//
}

