
#ifndef __NRF_H
#define __NRF_H
#include <main.h>

//NRF
#define NRF_READ_REG        0x00  //üĴ,5λΪĴַ
#define NRF_WRITE_REG       0x20  //дüĴ,5λΪĴַ
#define NRF_RD_RX_PLOAD     0x61  //RXЧ,1~32ֽ
#define NRF_WR_TX_PLOAD     0xA0  //дTXЧ,1~32ֽ
#define NRF_FLUSH_TX        0xE1  //TX FIFOĴ.ģʽ
#define NRF_FLUSH_RX        0xE2  //RX FIFOĴ.ģʽ
#define NRF_REUSE_TX_PL     0xE3  //ʹһ,CEΪ,ݰϷ.
#define NRF_NOP             0xFF  //ղ,״̬Ĵ
#define NRF_R_RX_PL_WID         0x60
#define NRF_W_ACK_PLOAD         0xA8
#define NRF_WR_TX_PLOAD_NACK    0xB0
//NRFĴַ
#define NRF_CONFIG          0x00  //üĴַ;bit0:1ģʽ,0ģʽ;bit1:ѡ;bit2:CRCģʽ;bit3:CRCʹ;bit4:жMAX_RT(ﵽطж)ʹ;bit5:жTX_DSʹ;bit6:жRX_DRʹ
#define NRF_EN_AA           0x01  //ʹԶӦ  bit0~5,Ӧͨ0~5
#define NRF_EN_RXADDR       0x02  //յַ,bit0~5,Ӧͨ0~5
#define NRF_SETUP_AW        0x03  //õַ(ͨ):bit1,0:00,3ֽ;01,4ֽ;02,5ֽ;
#define NRF_SETUP_RETR      0x04  //Զط;bit3:0,Զط;bit7:4,Զطʱ 250*x+86us
#define NRF_RF_CH           0x05  //RFͨ,bit6:0,ͨƵ;
#define NRF_RF_SETUP        0x06  //RFĴ;bit3:(0:1Mbps,1:2Mbps);bit2:1,书;bit0:Ŵ
#define NRF_STATUS          0x07  //״̬Ĵ;bit0:TX FIFO־;bit3:1,ͨ(:6);bit4,ﵽط;bit5:ݷж;bit6:ж;
#define NRF_MAX_TX          0x10  //ﵽʹж
#define NRF_TX_OK           0x20  //TXж
#define NRF_RX_OK           0x40  //յж
#define NRF_OBSERVE_TX      0x08  //ͼĴ,bit7:4,ݰʧ;bit3:0,ط
#define NRF_CD              0x09  //زĴ,bit0,ز;
#define NRF_RX_ADDR_P0      0x0A  //ͨ0յַ,󳤶5ֽ,ֽǰ
#define NRF_RX_ADDR_P1      0x0B  //ͨ1յַ,󳤶5ֽ,ֽǰ
#define NRF_RX_ADDR_P2      0x0C  //ͨ2յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define NRF_RX_ADDR_P3      0x0D  //ͨ3յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define NRF_RX_ADDR_P4      0x0E  //ͨ4յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define NRF_RX_ADDR_P5      0x0F  //ͨ5յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define NRF_TX_ADDR         0x10  //͵ַ(ֽǰ),ShockBurstTMģʽ,RX_ADDR_P0˵ַ
#define NRF_RX_PW_P0        0x11  //ͨ0Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_RX_PW_P1        0x12  //ͨ1Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_RX_PW_P2        0x13  //ͨ2Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_RX_PW_P3        0x14  //ͨ3Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_RX_PW_P4        0x15  //ͨ4Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_RX_PW_P5        0x16  //ͨ5Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_FIFO_STATUS     0x17  //FIFO״̬Ĵ;bit0,RX FIFOĴձ־;bit1,RX FIFO־;bit2,3,;bit4,TX FIFOձ־;bit5,TX FIFO־;bit6,1,ѭһݰ.0,ѭ;
#define NRF_DYNPD           0x1C
#define NRF_FEATURE         0x1D
//24L01ͽݿȶ
#define NRF_TX_ADDR_WIDTH    5      //5ֽڵĵַ
#define NRF_RX_ADDR_WIDTH    5      //5ֽڵĵַ
#define NRF_TX_PLOAD_WIDTH  32      //32ֽڵûݿ
#define NRF_RX_PLOAD_WIDTH  32      //32ֽڵûݿ

//NRF״̬Ĵ־λ
#define NRF_STATUS_RX_DR    (1 << 6)  //жϱ־λ
#define NRF_STATUS_TX_DS    (1 << 5)  //жϱ־λ
#define NRF_STATUS_MAX_RT   (1 << 4)  //ﵽطжϱ־λ

//nrf
#define NRF24L01_CE_L()   GPIO_ResetBits(GPIOA,GPIO_Pin_8)
#define NRF24L01_CE_H()   GPIO_SetBits  (GPIOA,GPIO_Pin_8)

#define NRF24L01_CS_L()   GPIO_ResetBits(GPIOB,GPIO_Pin_12)
#define NRF24L01_CS_H()   GPIO_SetBits  (GPIOB,GPIO_Pin_12)

void nrf_init(void);
unsigned char nrf_write_reg(unsigned char reg,unsigned char value);
unsigned char nrf_read_reg(unsigned char reg);
unsigned char nrf_write_buf(unsigned char reg, unsigned char *pBuf, unsigned char len);
unsigned char nrf_read_buf(unsigned char reg,unsigned char *pBuf,unsigned char len);
void nrf_clear_rx_fifo( void );
void nrf_clear_tx_fifo( void );
uint8_t nrf_check_presence(void);

#endif















