#include "main.h"

// SPI2ʼ
void spi2_init(void)
{
    // ʹ GPIOB  SPI2 ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);

    // GPIOB13,14,15 ʼ (SPI2)
    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15; // PB13: SPI2_SCK, PB14: SPI2_MISO, PB15: SPI2_MOSI
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; // 
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; // ٶ50MHz
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    // SPI2 ʼ
    SPI_InitTypeDef  SPI_InitStructure;
    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI2, &SPI_InitStructure);
    //  SPI2
    SPI_Cmd(SPI2, ENABLE);
}

uint8_t spi2_read_write(uint8_t TxData)
{
    while (!(SPI2->STATR & SPI_STATR_TXE)); // ȴͻ
    SPI2->DATAR = TxData; // һֽ
    while (!(SPI2->STATR & SPI_STATR_RXNE)); // ȴջǿ
    return (uint8_t)(SPI2->DATAR); // ؽյ
}

