/*
 * ctrl_Task.c
 *
 *  Created on: 2024617
 *      Author: 14662
 */

#include "main.h"

/*                 4(R)        2(L)                      */

/*                 3(L)        1(R)                      */

static uint16_t MOTO1_PWM,MOTO2_PWM,MOTO3_PWM,MOTO4_PWM;
static PID AI_Pitch,AO_Pitch;
static PID AI_Roll ,AO_Roll ;
static PID AI_Yaw  ;
static int n;

void ctrl_task(void * pvParameters)
{
    AO_Pitch.P=0.05f;       AO_Pitch.I=0.0000f;     AO_Pitch.D=0.02f;
    AO_Roll .P=0.05f;       AO_Roll .I=0.0000f;     AO_Roll .D=0.02f;

    AI_Pitch.P=100.0f;      AI_Pitch.I=1.2000f;     AI_Pitch.D=30.00f;
    AI_Roll .P=100.0f;      AI_Roll .I=1.2000f;     AI_Roll .D=30.00f;
    AI_Yaw  .P=100.0f;      AI_Yaw  .I=1.2000f;     AI_Yaw  .D=30.00f;

    for(int i=0;i<5000;i++)vTaskDelay(configTICK_RATE_HZ/400);

    while(1)
    {
        //̬⻷
        if(4==n++)
        {
            //ƫ
            AO_Pitch.E  =(pitch_tar*30.0f-pitch*57.3f);
            AO_Roll .E  =(roll_tar *30.0f-roll *57.3f);
            //ƫ
            AO_Pitch.ES+=AO_Pitch.E;if(throttle<50)AO_Pitch.ES=0;
            AO_Roll .ES+=AO_Roll .E;if(throttle<50)AO_Roll .ES=0;

            //ƫ΢
            AO_Pitch.EC =gy_lpf_1;
            AO_Roll .EC =gx_lpf_1;

            //
            AO_Pitch.O=AO_Pitch.P*AO_Pitch.E+AO_Pitch.I*AO_Pitch.ES+AO_Pitch.D*AO_Pitch.EC;
            AO_Roll .O=AO_Roll .P*AO_Roll .E+AO_Roll .I*AO_Roll .ES+AO_Roll .D*AO_Roll .EC;
            n=0;
        }

        //̬ڻ
        {
            //ƫ
            AI_Pitch.E  =(AO_Pitch.O-gx_lpf_2);//pitch_tar //һϹķУAO_Pitch.O滻pitch_tarͿлɴڻƣȥģʽɴԽ
            AI_Roll .E  =(AO_Roll .O-gy_lpf_2);//roll_tar  //һϹķУAO_Roll .O滻roll_tar ͿлɴڻƣȥģʽɴԽ
            AI_Yaw  .E  =(yaw_tar   -gz_lpf_2);
            //ƫ
            AI_Pitch.ES+=AI_Pitch.E;if(throttle<50){AI_Pitch.ES=0;}
            AI_Roll .ES+=AI_Roll .E;if(throttle<50){AI_Roll .ES=0;}
            AI_Yaw  .ES+=AI_Yaw  .E;if(throttle<50){AI_Yaw  .ES=0;}
            //ƫ΢
            AI_Pitch.EC =AI_Pitch.E-AI_Pitch.EL;AI_Pitch.EL =AI_Pitch.E;
            AI_Roll .EC =AI_Roll .E-AI_Roll .EL;AI_Roll .EL =AI_Roll .E;
            AI_Yaw  .EC =AI_Yaw  .E-AI_Yaw  .EL;AI_Yaw  .EL =AI_Yaw  .E;
            //
            AI_Pitch.O=AI_Pitch.P*AI_Pitch.E+AI_Pitch.I*AI_Pitch.ES+AI_Pitch.D*AI_Pitch.EC;
            AI_Roll .O=AI_Roll .P*AI_Roll .E+AI_Roll .I*AI_Roll .ES+AI_Roll .D*AI_Roll .EC;
            AI_Yaw  .O=AI_Yaw  .P*AI_Yaw  .E+AI_Yaw  .I*AI_Yaw  .ES+AI_Yaw  .D*AI_Yaw  .EC;
        }

        //
        if(throttle>50)
        {
            MOTO1_PWM=1000+throttle+AI_Pitch.O+AI_Roll.O+AI_Yaw.O;//
            MOTO2_PWM=1000+throttle-AI_Pitch.O+AI_Roll.O-AI_Yaw.O;//
            MOTO3_PWM=1000+throttle+AI_Pitch.O-AI_Roll.O-AI_Yaw.O;//
            MOTO4_PWM=1000+throttle-AI_Pitch.O-AI_Roll.O+AI_Yaw.O;//
            tim3_pwm(MOTO1_PWM,MOTO2_PWM,MOTO3_PWM,MOTO4_PWM);
        }
        else
        {
            MOTO1_PWM=1000;
            MOTO2_PWM=1000;
            MOTO3_PWM=1000;
            MOTO4_PWM=1000;
            tim3_pwm(MOTO1_PWM,MOTO2_PWM,MOTO3_PWM,MOTO4_PWM);
        }

        vTaskDelay(configTICK_RATE_HZ/400);
    }
}

