#include "main.h"

uint8_t bzw_11;
uint8_t task11 = 0;
uint8_t task12 = 0;
uint8_t task13 = 0;
uint8_t task14 = 0;
uint8_t task15 = 0;

TaskHandle_t start_task_handler;
void start_task(void * pvParameters)
{
    // ʼӲ
    spi3_init();
    spi2_init();
    tim3_pwm_init();

    gy91_init();
    nrf_init();
    bzw_11 = nrf_check_presence();
    led_init();

    // ң
    BaseType_t result1;
    #define telectrl_task_prio   1
    #define telectrl_stk_size    512
    TaskHandle_t telectrl_task_handler;
    result1 = xTaskCreate((TaskFunction_t ) telectrl_task,
              (char*          ) "telectrl_task",
              (uint16_t       ) telectrl_stk_size,
              (void *         ) NULL,
              (UBaseType_t    ) telectrl_task_prio,
              (TaskHandle_t*    ) &telectrl_task_handler);
    if (result1 == pdPASS) {
        task11 = 1;
        printf("Task created successfully.\n");
    } else {
        task11 = 2;
        printf("Task creation failed with error code %d\n", result1);
    }

    // 
    BaseType_t result2;
    #define ctrl_task_prio   2
    #define ctrl_stk_size    512
    TaskHandle_t ctrl_task_handler;
    result2 = xTaskCreate((TaskFunction_t ) ctrl_task,
              (char*          ) "ctrl_task",
              (uint16_t       ) ctrl_stk_size,
              (void *         ) NULL,
              (UBaseType_t    ) ctrl_task_prio,
              (TaskHandle_t*    ) &ctrl_task_handler);
    if (result2 == pdPASS) {
        task12 = 1;
        printf("Task created successfully.\n");
    } else {
        task12 = 2;
        printf("Task creation failed with error code %d\n", result2);
    }

    // IMU
    BaseType_t result3;
    #define imu_task_prio   3
    #define imu_stk_size    512
    TaskHandle_t imu_task_handler;
    result3 = xTaskCreate((TaskFunction_t ) imu_task,
              (char*          ) "imu_task",
              (uint16_t       ) imu_stk_size,
              (void *         ) NULL,
              (UBaseType_t    ) imu_task_prio,
              (TaskHandle_t*    ) &imu_task_handler);
    if (result3 == pdPASS) {
        task13 = 1;
        printf("Task created successfully.\n");
    } else {
        task13 = 2;
        printf("Task creation failed with error code %d\n", result3);
    }

    // TEMP
    BaseType_t result4;
    #define temp_task_prio   4
    #define temp_stk_size    1024
    TaskHandle_t tamp_task_handler;
    result4 = xTaskCreate((TaskFunction_t ) temp_task,
              (char*          ) "temp_task",
              (uint16_t       ) temp_stk_size,
              (void *         ) NULL,
              (UBaseType_t    ) temp_task_prio,
              (TaskHandle_t*    ) &tamp_task_handler);
    if (result4 == pdPASS) {
        task14 = 1;
        printf("Task created successfully.\n");
    } else {
        task14 = 2;
        printf("Task creation failed with error code %d\n", result4);
    }

    led_flash();
    vTaskDelete(start_task_handler);
}

int main(void)
{
    // NVIC
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    USART1_Init(115200);
    printf("STAR...\n");


    BaseType_t result5;

    // ʼڴ
    size_t freeHeapSize = xPortGetFreeHeapSize();
    printf("Initial free heap size: %d bytes\n", freeHeapSize);

    // 
    #define start_task_prio   5
    #define start_stk_size    2048
    result5 = xTaskCreate((TaskFunction_t ) start_task,
              (char*          ) "main_task_task",
              (uint16_t       ) start_stk_size,
              (void *         ) NULL,
              (UBaseType_t    ) start_task_prio,
              (TaskHandle_t*    ) &start_task_handler);
    if (result5 == pdPASS) {
        task15 = 1;
    } else {
        task15 = 2;
        printf("Task creation failed with error code %d\n", result5);
    }

    // ٴμڴ
    freeHeapSize = xPortGetFreeHeapSize();
    printf("Free heap size after task creation: %d bytes\n", freeHeapSize);

    // 
    vTaskStartScheduler();
}

//configTOTAL_HEAP_SIZE
