#include "main.h"

// SPI3 ʼ
void spi3_init(void)
{
    // ʹ GPIOB  SPI3 ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI3, ENABLE);

    // GPIOB3,4,5 ʼ (SPI3)
    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5; // PB3: SPI3_SCK, PB4: SPI3_MISO, PB5: SPI3_MOSI
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; // 
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; // ٶ50MHz
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    // ƬѡţCS/SS
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    GPIO_SetBits(GPIOB, GPIO_Pin_6); // Ƭѡ

    // SPI3 ʼ
    SPI_InitTypeDef  SPI_InitStructure;
    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;//SPI˫ģʽ:SPIΪ˫˫ȫ˫
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;//SPIģʽ:ΪSPI
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;//SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;//ͬʱӵĿ״̬Ϊߵƽ
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;//ͬʱӵĵڶأ½ݱ
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;//NSSźӲNSSܽţʹSSIλ:ڲNSSźSSIλ
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;//岨ԤƵֵ:ԤƵֵΪ256
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;//ָݴMSBλLSBλʼ:ݴMSBλʼ
    SPI_InitStructure.SPI_CRCPolynomial = 7;//CRCֵĶʽ
    SPI_Init(SPI3, &SPI_InitStructure);//SPI_InitStructָĲʼSPIxĴ

    //  SPI3
    SPI_Cmd(SPI3, ENABLE);
}

uint8_t spi3_read_write(uint8_t TxData)
{
    while (!(SPI3->STATR & SPI_STATR_TXE)); // ȴͻ
    SPI3->DATAR = TxData; // һֽ
    while (!(SPI3->STATR & SPI_STATR_RXNE)); // ȴջǿ
    return (uint8_t)(SPI3->DATAR); // ؽյ
}

// SPI3 дĴ
uint8_t spi3_wirte_reg(uint8_t reg_addr, uint8_t reg_val)
{
    spi3_read_write(reg_addr & 0x7F); // дַ
    spi3_read_write(reg_val);
    return 0;
}

// SPI3 Ĵ
uint8_t spi3_read_reg(uint8_t reg_addr)
{
    spi3_read_write(reg_addr | 0x80); // ַ
    return spi3_read_write(0xFF); // ͿֽԶȡ
}
