
#include "main.h"


void tim3_pwm_init(void)
{
    // ʼGPIOṹ
    GPIO_InitTypeDef GPIO_InitStructure;
    TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;
    TIM_OCInitTypeDef TIM_OCInitStructure;

    // ʹʱ
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB, ENABLE);
    // GPIOָ

    // GPIOģʽʼ
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    // Ƶռձ
    TIM_TimeBaseStructure.TIM_Prescaler = 83; // ԤƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseStructure.TIM_Period = 2499; // 
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);

    // ͨ
    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
    TIM_OCInitStructure.TIM_Pulse = 1000; // ռձ

    // ͨʼ
    TIM_OC1Init(TIM3, &TIM_OCInitStructure);
    TIM_OC2Init(TIM3, &TIM_OCInitStructure);
    TIM_OC3Init(TIM3, &TIM_OCInitStructure);
    TIM_OC4Init(TIM3, &TIM_OCInitStructure);

    // ͨԤװʹ
    TIM_OC1PreloadConfig(TIM3, TIM_OCPreload_Enable);
    TIM_OC2PreloadConfig(TIM3, TIM_OCPreload_Enable);
    TIM_OC3PreloadConfig(TIM3, TIM_OCPreload_Enable);
    TIM_OC4PreloadConfig(TIM3, TIM_OCPreload_Enable);

    // ʱʹ
    TIM_ARRPreloadConfig(TIM3, ENABLE);
    TIM_Cmd(TIM3, ENABLE);
    TIM_CtrlPWMOutputs(TIM3, ENABLE);
}
void tim3_pwm(uint16_t MOTO1_PWM,uint16_t MOTO2_PWM,uint16_t MOTO3_PWM,uint16_t MOTO4_PWM)
{

    //ֹ
    MOTO1_PWM = (MOTO1_PWM > 2000) ? 2000 : (MOTO1_PWM < 1000) ? 1000 : MOTO1_PWM;
    MOTO2_PWM = (MOTO2_PWM > 2000) ? 2000 : (MOTO2_PWM < 1000) ? 1000 : MOTO2_PWM;
    MOTO3_PWM = (MOTO3_PWM > 2000) ? 2000 : (MOTO3_PWM < 1000) ? 1000 : MOTO3_PWM;
    MOTO4_PWM = (MOTO4_PWM > 2000) ? 2000 : (MOTO4_PWM < 1000) ? 1000 : MOTO4_PWM;

    TIM3->CH1CVR = MOTO1_PWM;
    TIM3->CH2CVR = MOTO2_PWM;
    TIM3->CH3CVR = MOTO3_PWM;
    TIM3->CH4CVR = MOTO4_PWM;
}

