/*
 * main.h
 *
 *  Created on: 2024617
 *      Author: 14662
 */

#ifndef USER_MAIN_H_
#define USER_MAIN_H_


#include "debug.h"
#include "FreeRTOS.h"
#include "task.h"

#include "flash.h"
#include "gy91.h"
#include "led.h"
#include "nrf.h"
#include "spi1.h"
#include "spi2.h"
#include "tim3.h"
#include "usart1.h"
#include "MLX90640_API.h"
#include "MLX90640_I2C_Driver.h"
#include "gps.h"


#include "ctrl_Task.h"
#include "imu_Task.h"
#include "telectrl_Task.h"
#include "temp_Task.h"

#include "stdio.h"
#include "math.h"
#include "string.h"



#endif /* USER_MAIN_H_ */
